// !!!!!!!!!!!! mHUD 1.0 -> Enhanced Mortar Rangefinder! <- 5/4/99 !!!!!!!!!!!!
// 
// By:
//    Cowboy
//    cowboy@planetstarsiege.com
//    http://www.planetstarsiege.com/cowboy/
//    ICQ# 31184463
// 
// Pretty self-explanatory.. This creates an transparent-rangefinder bitmap
// that gets displayed ONLY if your current weapon is the Mortar. I plan on
// adding in a grenade launcher bitmap option, as well as breaking the 800x600
// resolution barrier.. 
//
// Requires PrestoHUD 0.93+ and fully compatible with CmdHUD 1.0+
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// 
// Installation notes:
// 
// Unzip mHUD.gui into the tribes\gui directory. If this directory doesn't
// exist, create it! I have included my personal reticle (h_reticle.bmp) here,
// you can put this file in the tribes\base directory. Unzip all other files
// into \config\cowboy directory and add line: Include("cowboy\\mHUD.cs"); to
// your autoexec.cs file somewhere AFTER the exec("presto\\install.cs"); line.
// 
// NOTE: If you have a reticle with an 'enhanced rangefinder' for mortaring,
//       either use my included reticle or remove the rangefinder from yours,
//       as they will no doubt clash horribly! (what a mess...)
//
//       *** So far, this only supports 800x600! i will be working on ***
//       *** other versions, but.. first things first!                ***
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// 
// (c) 1999 Cowboy, whatever... I hope you enjoy this, and all that i ask is
// that you give me props for it.. enjoy!
//
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

Include("presto\\Event.cs");
Include("presto\\Inventory.cs");

//
// User settings:
//
// $mHUD::UpdateTime: how often we check for Mortar weapon status 
// $mHUD::InitInvTime: how long to wait before inventory station first loads
//
// you probably won't need to change these.. but if you do, here they are!

$mHUD::UpdateTime = 0.25;
$mHUD::InitInvTime = 0.5;

//
// For Presto Pack 0.93+, this displays script info in a box on the main
// menu screen, kind of an 'Advertisement/Info Box' for installed scripts.
//

if ($Presto::version >= 0.93) {
	Presto::AddScriptBanner(mHUD,
		"<jc><f2>mHUD 1.0 <f1>by <f2>Cowboy\n" @
		"<f1>Enhanced Mortar Rangefinder\n" @
		"\n" @
		"<f0>Note: Only supports <f1>800x600\n" @
		"<f0>right now, please see readme\n"@
		"for more details... <f1>Thank you!\n" @
		"\n" @
		"<f1>Released 5/4/99 by Cowboy\n" @
		"cowboy@planetstarsiege.com");
	}
//
// add tag, hopefully this id# will never be used!
//
IDBMP_MORTAR_HUD = 00160950, "cowboy\\mHUD.bmp"; 

//
// This constantly runs and checks to see if the Mortar weapon is loaded
//
function mHUD::Timer() {
	if (!$mHUD::Initialized && getMountedItem(0) != -1) {
		$mHUD::Initialized = true;
		mHUD::Init();
		}

	if (included("cowboy\\CmdHUD.cs")) {
		if ($Inv::Name[getMountedItem(0)] == "Mortar") {
			$mHUD::IsVisible = true;
			control::setvisible(mHUD::PlayGui, true);
			if (included("cowboy\\CmdHUD.cs") && !$CmdHUD::MapState)
				control::setvisible(mHUD::CommandGui, false);
			else
				control::setvisible(mHUD::CommandGui, true);
			control::setvisible(mHUD::CmdInventoryGui, true);
			}
		else if ($Inv::Name[getMountedItem(0)] != "Mortar") {
			$mHUD::IsVisible = false;
			control::setvisible(mHUD::PlayGui, false);
			control::setvisible(mHUD::CommandGui, false);
			control::setvisible(mHUD::CmdInventoryGui, false);
			}
		}
	else if ($Inv::Name[getMountedItem(0)] == "Mortar") {
		$mHUD::IsVisible = true;
		control::setvisible(mHUD::PlayGui, true);
		}
	else if ($Inv::Name[getMountedItem(0)] != "Mortar") {
		$mHUD::IsVisible = false;
		control::setvisible(mHUD::PlayGui, false);
		}

	schedule("mHUD::Timer();", $mHUD::UpdateTime);
	}

//
// Initialize the objects: load the gui, get the IDs, move stuff around
//
function mHUD::Init() {
	guiPushDialog(MainWindow, "gui\\mhud.gui");
	guiPopDialog(MainWindow, "gui\\mhud.gui");

	$mHUD::PlayGui = Group::GetObject(NameToID(ts_140114), 0);
	$mHUD::CommandGui = Group::GetObject(NameToID(ts_140114), 1);
	$mHUD::CmdInventoryGui = Group::GetObject(NameToID(ts_140114), 2);

	addToSet(PlayGui, $mHUD::PlayGui);
	control::setvisible(mHUD::PlayGui, false);
	echo("mHUD - PlayGUI Initialized");

	if (included("cowboy\\CmdHUD.cs")) {
		addToSet(CommandGui, $mHUD::CommandGui);
		control::setvisible(mHUD::CommandGui, false);
		echo("mHUD - CmdHUD CommandGUI Initialized");
		}

	Event::Attach(eventConnected, mHUD::Reset);
	Event::Attach(eventChangeMission, mHUD::Reset);
	}

//
// Because the CmdInventoryGui isn't loaded until you actually access the
// inventory screen, you have to wait until that happens to add the object!
//
function mHUD::InitInvCommandGui() {
	if (included("cowboy\\CmdHUD.cs")) {
		addToSet(CmdInventoryGui, $mHUD::CmdInventoryGui);
		control::setvisible(mHUD::CmdInventoryGui, false);
		echo("mHUD - CmdHUD InventoryGUI Initialized");
		}
	}

//
// Detect opening the inventory screen
//
function mHUD::GuiOpen(%gui) {
	if (%gui == CmdInventoryGui) {
		schedule("mHUD::InitInvCommandGui();", $mHUD::InitInvTime);
		schedule("Event::Detach(eventGuiOpen, mHUD::GuiOpen);", $mHUD::InitInvTime + 1);
		}
	}

//
// Reset all objects and variables
//
function mHUD::Reset() {
	control::setvisible(mHUD::Playgui, false);
	control::setvisible(mHUD::Commandgui, false);
	control::setvisible(mHUD::CmdInventorygui, false);
	echo("mHUD Reset");
	}

$mHUD::Initialized = false;
Event::Attach(eventConnected, mHUD::Timer);
Event::Attach(eventGuiOpen, mHUD::GuiOpen);
